## webcamoid 9.0.0

=== CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(Webcamoid)

include(libAvKys/cmake/ProjectCommons.cmake)

if (ANDROID)
    find_package(Qt5 COMPONENTS Core REQUIRED)
endif ()

add_subdirectory(libAvKys)
add_subdirectory(StandAlone)

# NOTE for other developers: TARGET_ARCH is intended to be used as a reference
# for the deploy tool, so don't rush on adding new architectures unless you
# want to create a binary distributable for that architecture.
# Webcamoid build is not affected in anyway by the value of TARGET_ARCH, if the
# build fails its something else and totally unrelated to that variable.

# Try detecting Qmake executable.

if ("${QT_QMAKE_EXECUTABLE}" STREQUAL "")
    find_program(QT_QMAKE_EXECUTABLE_BIN qmake)
else ()
    find_program(QT_QMAKE_EXECUTABLE_BIN "${QT_QMAKE_EXECUTABLE}")
endif ()

# Retrieve useful variables related to Qt installation.

if (QT_QMAKE_EXECUTABLE_BIN)
    execute_process(COMMAND ${QT_QMAKE_EXECUTABLE_BIN} -query QT_INSTALL_PREFIX
                    OUTPUT_VARIABLE QT_INSTALL_PREFIX
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${QT_QMAKE_EXECUTABLE_BIN} -query QT_INSTALL_LIBS
                    OUTPUT_VARIABLE QT_INSTALL_LIBS
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${QT_QMAKE_EXECUTABLE_BIN} -query QT_INSTALL_BINS
                    OUTPUT_VARIABLE QT_INSTALL_BINS
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${QT_QMAKE_EXECUTABLE_BIN} -query QT_INSTALL_PLUGINS
                    OUTPUT_VARIABLE QT_INSTALL_PLUGINS
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${QT_QMAKE_EXECUTABLE_BIN} -query QT_INSTALL_QML
                    OUTPUT_VARIABLE QT_INSTALL_QML
                    OUTPUT_STRIP_TRAILING_WHITESPACE)

    if (QT_INSTALL_PREFIX)
        set(QT_INSTALL_SRC ${QT_INSTALL_PREFIX}/src)
    endif ()
endif ()

# Set platform related variables to be used in package_info.conf.

if (ANDROID)
    set(TARGET_PLATFORM android)
    set(BUILD_INFO_FILE ${DATAROOTDIR}/build-info.txt)

    if (${QT_VERSION_MAJOR} GREATER_EQUAL 6)
        set(MAIN_EXECUTABLE ${BINDIR}/Webcamoid_${CMAKE_ANDROID_ARCH_ABI})
    else ()
        set(MAIN_EXECUTABLE ${BINDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}Webcamoid_${CMAKE_ANDROID_ARCH_ABI}${CMAKE_SHARED_LIBRARY_SUFFIX})
    endif ()

    set(APP_LIBDIR ${LIBDIR})
    set(OUTPUT_FORMATS "AndroidAPK")
    set(TARGET_ARCH ${CMAKE_ANDROID_ARCH_ABI})
    set(OUTPUT_QML_DIR ${DATAROOTDIR}/android_rcc_bundle/qml)
    set(OUTPUT_QT_PLUGINS_DIR ${DATAROOTDIR}/android_rcc_bundle/plugins)
elseif (APPLE)
    set(TARGET_PLATFORM mac)
    set(BUILD_INFO_FILE ${DATAROOTDIR}/build-info.txt)
    set(MAIN_EXECUTABLE ${BINDIR}/Webcamoid)
    set(APP_LIBDIR ${LIBDIR})
    set(QTIFW_TARGET_DIR "\@ApplicationsDir\@/Webcamoid")
    set(OUTPUT_FORMATS "Dmg, MacPkg")
    set(INSTALLER_ICON StandAlone/share/themes/WebcamoidTheme/icons/webcamoid.icns)
    set(RUN_PROGRAM "\@TargetDir\@/${MAIN_EXECUTABLE}")
    set(OUTPUT_QML_DIR ${DATAROOTDIR}/qml)
    set(OUTPUT_QT_PLUGINS_DIR ${EXECPREFIX}/Plugins)
    set(QT_CONF_FILE ${DATAROOTDIR}/qt.conf)
elseif (WIN32)
    set(TARGET_PLATFORM windows)
    set(BUILD_INFO_FILE ${DATAROOTDIR}/build-info.txt)
    set(MAIN_EXECUTABLE ${BINDIR}/webcamoid.exe)
    set(APP_LIBDIR ${LIBDIR})

    include(CheckCXXSourceCompiles)
    check_cxx_source_compiles("
    #include <windows.h>

    #ifndef _M_X64
        #error Not WIN64
    #endif

    int main()
    {
        return 0;
    }" IS_WIN64_TARGET)

    check_cxx_source_compiles("
    #include <windows.h>

    #ifndef _M_IX86
        #error Not WIN32
    #endif

    int main()
    {
        return 0;
    }" IS_WIN32_TARGET)

    check_cxx_source_compiles("
    #include <windows.h>

    #ifndef _M_ARM64
        #error Not ARM64
    #endif

    int main()
    {
        return 0;
    }" IS_WIN64_ARM_TARGET)

    check_cxx_source_compiles("
    #include <windows.h>

    #ifndef _M_ARM
        #error Not ARM
    #endif

    int main()
    {
        return 0;
    }" IS_WIN32_ARM_TARGET)

    if (IS_WIN64_TARGET OR IS_WIN64_ARM_TARGET)
        set(QTIFW_TARGET_DIR "\@ApplicationsDirX64\@/Webcamoid")
    else ()
        set(QTIFW_TARGET_DIR "\@ApplicationsDirX86\@/Webcamoid")
    endif()

    if (IS_WIN64_TARGET)
        set(TARGET_ARCH win64)
    elseif (IS_WIN64_ARM_TARGET)
        set(TARGET_ARCH win64_arm)
    elseif (IS_WIN32_TARGET)
        set(TARGET_ARCH win32)
    elseif (IS_WIN32_ARM_TARGET)
        set(TARGET_ARCH win32_arm)
    else ()
        set(TARGET_ARCH unknown)
    endif()

    set(OUTPUT_FORMATS "CompressedZip, Nsis")
    set(INSTALLER_ICON StandAlone/share/themes/WebcamoidTheme/icons/hicolor/256x256/webcamoid.ico)
    set(RUN_PROGRAM "${MAIN_EXECUTABLE}")
    set(PROGRAM_ARGS "-c \"%%~dp0${DATAROOTDIR}\\config\"")
    set(OUTPUT_QML_DIR ${LIBDIR}/qt/qml)
    set(OUTPUT_QT_PLUGINS_DIR ${LIBDIR}/qt/plugins)
    set(QT_CONF_FILE ${BINDIR}/qt.conf)
    set(EXTRA_LIBS_LIST
        libeay32.dll
        ssleay32.dll
        libEGL.dll
        libGLESv2.dll
        D3DCompiler_43.dll
        D3DCompiler_46.dll
        D3DCompiler_47.dll)
    list(JOIN EXTRA_LIBS_LIST ", " EXTRA_LIBS)
else ()
    set(TARGET_PLATFORM posix)
    set(BUILD_INFO_FILE ${DATAROOTDIR}/build-info.txt)
    set(MAIN_EXECUTABLE ${BINDIR}/webcamoid)
    set(APP_LIBDIR ${LIBDIR})
    set(QTIFW_TARGET_DIR "\@HomeDir\@/Webcamoid")
    set(OUTPUT_FORMATS "AppImage, CompressedTarXz, QtIFW")
    set(INSTALLER_ICON StandAlone/share/themes/WebcamoidTheme/icons/hicolor/128x128/webcamoid.png)
    set(RUN_PROGRAM "\@TargetDir\@/webcamoid.sh")
    set(OUTPUT_QML_DIR ${LIBDIR}/qt/qml)
    set(OUTPUT_QT_PLUGINS_DIR ${LIBDIR}/qt/plugins)
    set(QT_CONF_FILE ${BINDIR}/qt.conf)
endif ()

# Try detecting the target platform.

if (UNIX AND NOT APPLE AND NOT ANDROID)
    include(CheckCXXSourceCompiles)
    check_cxx_source_compiles("
    #ifndef __linux__
        #error Not Linux
    #endif

    int main()
    {
        return 0;
    }" IS_LINUX)

    check_cxx_source_compiles("
    #ifndef __FreeBSD__
        #error Not FreeBSD
    #endif

    int main()
    {
        return 0;
    }" IS_FREEBSD)

    if (IS_LINUX)
        set(PKG_TARGET_PLATFORM linux)
    elseif (IS_FREEBSD)
        set(PKG_TARGET_PLATFORM freebsd)
    else ()
        set(PKG_TARGET_PLATFORM ${TARGET_PLATFORM})
    endif ()
else ()
    set(PKG_TARGET_PLATFORM ${TARGET_PLATFORM})
endif ()

# Try detecting the target architecture in GNU/Linux and Mac.

if (UNIX AND NOT ANDROID)
    include(CheckCXXSourceCompiles)
    check_cxx_source_compiles("
    #ifndef __x86_64__
        #error Not x64
    #endif

    int main()
    {
        return 0;
    }" IS_X86_64_TARGET)

    check_cxx_source_compiles("
    #ifndef __i386__
        #error Not x86
    #endif

    int main()
    {
        return 0;
    }" IS_I386_TARGET)

    check_cxx_source_compiles("
    #ifndef __aarch64__
        #error Not ARM64
    #endif

    int main()
    {
        return 0;
    }" IS_ARM64_TARGET)

    check_cxx_source_compiles("
    #ifndef __arm__
        #error Not ARM
    #endif

    int main()
    {
        return 0;
    }" IS_ARM_TARGET)

    check_cxx_source_compiles("
    #ifndef __riscv
        #error Not RISC-V
    #endif

    int main()
    {
        return 0;
    }" IS_RISCV_TARGET)

    if (IS_X86_64_TARGET)
        set(TARGET_ARCH x86_64)
    elseif (IS_I386_TARGET)
        set(TARGET_ARCH i386)
    elseif (IS_ARM64_TARGET)
        set(TARGET_ARCH arm64)
    elseif (IS_ARM_TARGET)
        set(TARGET_ARCH arm)
    elseif (IS_RISCV_TARGET)
        set(TARGET_ARCH riscv)
    else ()
        set(TARGET_ARCH unknown)
    endif ()
endif ()

find_package(PkgConfig)

# Try detecting VLC plugins install path.

pkg_check_modules(VLC_PLUGINS vlc-plugin)

if (VLC_PLUGINS_FOUND)
    pkg_get_variable(VLC_PLUGINS_DIR vlc-plugin pluginsdir)
elseif (APPLE AND NOT VLC_PLUGINS_FOUND)
    message("-- Checking for 'VLC'")

    # Check user defined VLC path first.

    if (NOT "${VLC_INSTALL_PATH}" STREQUAL "" AND EXISTS "${VLC_INSTALL_PATH}")
        set(VLCAPP_DIR "${VLCAPP_INSTALL_DIR}")
    endif()

    # Check VLC installed by homebrew.

    if ("${VLCAPP_DIR}" STREQUAL "")
        set(VLCAPPBIN "/usr/local/bin/vlc")

        if (EXISTS ${VLCAPPBIN})
            get_filename_component(VLCAPPBIN_PATH ${VLCAPPBIN} REALPATH)
            get_filename_component(VLCAPP_INSTALL_DIR ${VLCAPPBIN_PATH} DIRECTORY)
            set(VLCAPP_DIR "${VLCAPP_INSTALL_DIR}/VLC.app")
        endif()
    endif()

    # Check VLC manually installed by the user.

    if ("${VLCAPP_DIR}" STREQUAL "")
        set(VLCAPPDIR "/Applications/VLC.app")

        if (EXISTS "${VLCAPPDIR}")
            set(VLCAPP_DIR "${VLCAPPDIR}")
        endif()
    endif()

    if (NOT "${VLCAPP_DIR}" STREQUAL "")
        set(VLCAPP_PLUGINS_DIR "${VLCAPP_DIR}/Contents/MacOS/plugins")

        if (EXISTS ${VLCAPP_PLUGINS_DIR})
            message("--   Found VLC in '${VLCAPP_DIR}'")
            set(VLC_PLUGINS_DIR "${VLCAPP_PLUGINS_DIR}")
        else ()
            message("--   No 'VLC' found")
        endif ()
    else ()
        message("--   No 'VLC' found")
    endif ()
endif ()

# Try detecting GStreamer plugins install path.

pkg_check_modules(GST_PLUGINS gstreamer-1.0)

if (GST_PLUGINS_FOUND)
    pkg_get_variable(GST_PLUGINS_DIR gstreamer-1.0 pluginsdir)
endif ()

# Try detecting PipeWire plugins install path.

pkg_check_modules(PIPEWIRE_MODULES libpipewire-0.3)
pkg_check_modules(PIPEWIRE_SPA_PLUGINS libspa-0.2)

if (PIPEWIRE_MODULES_FOUND)
    pkg_get_variable(PIPEWIRE_MODULES_DIR libpipewire-0.3 moduledir)
endif ()

if (PIPEWIRE_SPA_PLUGINS_FOUND)
    pkg_get_variable(PIPEWIRE_SPA_PLUGINS_DIR libspa-0.2 plugindir)
endif ()

configure_file(package_info.conf.in package_info.conf)

if (ANDROID)
    configure_file(package_info_android.conf.in package_info_android.conf)
    configure_file(COPYING
                   "${CMAKE_BINARY_DIR}/android-build/${LICENSEDIR}/COPYING"
                   COPYONLY)
else ()
    if (WIN32 AND CMAKE_HOST_UNIX)
        configure_file(package_info_windows.conf.in package_info_windows.conf)
    endif ()

    install(FILES COPYING DESTINATION ${LICENSEDIR})
endif ()

if (UNIX AND NOT ANDROID AND NOT MACX)
    install(FILES webcamoid.desktop DESTINATION ${DATAROOTDIR}/applications)
endif ()

=== StandAlone/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(StandAlone)

include(../libAvKys/cmake/ProjectCommons.cmake)

set(UPDATE_TRANSLATIONS ON CACHE BOOL "Update translations when building")

if (UPDATE_TRANSLATIONS)
    add_subdirectory(Translations)
endif ()

add_subdirectory(src)

if (UNIX AND NOT APPLE AND NOT ANDROID)
    add_subdirectory(ManPages)
endif ()

=== libAvKys/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(LibAvKys)

include(cmake/ProjectCommons.cmake)

add_subdirectory(Lib)
add_subdirectory(Plugins)

=== StandAlone/ManPages/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(ManPages)

include(../../libAvKys/cmake/ProjectCommons.cmake)

set(MANPAGE StandAlone/share/man/webcamoid.1)
configure_file(src/webcamoid.1.in src/webcamoid.1)
find_program(GZIP_TOOL gzip)

if (GZIP_TOOL)
    add_custom_target(manpages ALL
                      ${GZIP_TOOL} -c9 webcamoid.1 > webcamoid.1.gz
                      DEPENDS src/webcamoid.1
                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src
                      BYPRODUCTS src/webcamoid.1.gz
                      VERBATIM
                      SOURCES src/webcamoid.1.in)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/src/webcamoid.1.gz DESTINATION ${CMAKE_INSTALL_MANDIR})
endif ()

=== StandAlone/Translations/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(Translations)

include(../../libAvKys/cmake/ProjectCommons.cmake)

set(LANGUAGES
    ca
    de
    el
    es
    et
    fr
    gl
    he
    hu
    it
    ja
    kab
    ko
    nb_NO
    nl
    oc
    pl
    pt_BR
    pt
    ru
    si
    sv
    tr
    uk
    vi
    zh_CN
    zh_TW)

foreach (LANG IN LISTS LANGUAGES)
    configure_file(${CMAKE_SOURCE_DIR}/StandAlone/share/ts/${LANG}.ts
                   ${CMAKE_BINARY_DIR}/StandAlone/share/ts/${LANG}.ts
                   COPYONLY)
endforeach ()

# Update translations.
find_program(LUPDATE_TOOL lupdate)

if (LUPDATE_TOOL)
    foreach (LANG IN LISTS LANGUAGES)
        add_custom_target(tranlation_${LANG}_ts ALL
                          ${LUPDATE_TOOL} -no-obsolete
                                          ${CMAKE_SOURCE_DIR}/libAvKys
                                          ${CMAKE_SOURCE_DIR}/StandAlone
                                          -target-language ${LANG}
                                          -ts ${CMAKE_SOURCE_DIR}/StandAlone/share/ts/${LANG}.ts
                          VERBATIM)
    endforeach ()
endif ()

# Compile translations files.
find_program(LRELEASE_TOOL lrelease)

if (LRELEASE_TOOL)
    foreach (LANG IN LISTS LANGUAGES)
        add_custom_target(tranlation_${LANG}_qm ALL
                          ${LRELEASE_TOOL} -removeidentical
                                           -compress ${CMAKE_SOURCE_DIR}/StandAlone/share/ts/${LANG}.ts
                                           -qm ${CMAKE_SOURCE_DIR}/StandAlone/share/ts/${LANG}.qm
                          DEPENDS tranlation_${LANG}_ts
                          BYPRODUCTS StandAlone/share/ts/${LANG}.qm
                          VERBATIM)
    endforeach ()
endif ()

# Update qrc file.
set(TRANSLATIONS_QRC ${CMAKE_SOURCE_DIR}/StandAlone/translations.qrc)

file(WRITE ${TRANSLATIONS_QRC} "<RCC>\n")
string(REPEAT " " 4 INDENT_RESOURCE)
file(APPEND ${TRANSLATIONS_QRC} "${INDENT_RESOURCE}<qresource prefix=\"/Webcamoid\">\n")
set(TRANSLATION_RESOURCES "")
string(REPEAT " " 8 INDENT_FILE)

foreach (LANG IN LISTS LANGUAGES)
    file(APPEND ${TRANSLATIONS_QRC} "${INDENT_FILE}<file>share/ts/${LANG}.qm</file>\n")
endforeach ()

file(APPEND ${TRANSLATIONS_QRC} "${INDENT_RESOURCE}</qresource>\n")
file(APPEND ${TRANSLATIONS_QRC} "</RCC>\n")

=== StandAlone/src/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(StandAloneSrc LANGUAGES CXX)

include(../../libAvKys/cmake/ProjectCommons.cmake)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_COMPONENTS
    Concurrent
    OpenGL
    Qml
    Quick
    QuickControls2
    Svg
    Widgets)

if (ANDROID)
    list(APPEND QT_COMPONENTS
         Xml
         AndroidExtras)
endif()

find_package(QT NAMES Qt${QT_VERSION_MAJOR} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${QT_MINIMUM_VERSION} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
set(PROJECT_SOURCES
    audiolayer.cpp
    audiolayer.h
    clioptions.cpp
    clioptions.h
    downloadmanager.cpp
    downloadmanager.h
    iconsprovider.cpp
    iconsprovider.h
    main.cpp
    mediatools.cpp
    mediatools.h
    pluginconfigs.cpp
    pluginconfigs.h
    recording.cpp
    recording.h
    updates.cpp
    updates.h
    videodisplay.cpp
    videodisplay.h
    videoeffects.cpp
    videoeffects.h
    videolayer.cpp
    videolayer.h
    ../DefaultTheme.qrc
    ../icons.qrc
    ../translations.qrc
    ../Webcamoid.qrc)

if (APPLE)
    list(APPEND PROJECT_SOURCES ../WebcamoidInfo.plist
                                ../share/themes/WebcamoidTheme/icons/webcamoid.icns)
    set_source_files_properties(../share/themes/WebcamoidTheme/icons/webcamoid.icns PROPERTIES
                                MACOSX_PACKAGE_LOCATION Resources)
elseif (WIN32)
    list(APPEND PROJECT_SOURCES ../Webcamoid.rc)
endif ()

if (${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    add_executable(StandAlone ${PROJECT_SOURCES})
else ()
    if (ANDROID)
        add_library(StandAlone SHARED ${PROJECT_SOURCES})
    else ()
        add_executable(StandAlone ${PROJECT_SOURCES})
    endif ()
endif ()

if (APPLE)
    string(TIMESTAMP YEAR "%Y")
    set_target_properties(StandAlone PROPERTIES
                          OUTPUT_NAME Webcamoid
                          MACOSX_BUNDLE TRUE
                          MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/../WebcamoidInfo.plist
                          MACOSX_BUNDLE_BUNDLE_NAME Webcamoid
                          MACOSX_BUNDLE_BUNDLE_VERSION ${VERSION}
                          MACOSX_BUNDLE_COPYRIGHT "Copyright (C)  2011-${YEAR}  Gonzalo Exequiel Pedone"
                          MACOSX_BUNDLE_GUI_IDENTIFIER com.webcamoidprj.webcamoid
                          MACOSX_BUNDLE_ICON_FILE webcamoid.icns
                          MACOSX_BUNDLE_INFO_STRING "Webcamoid, The ultimate webcam suite!"
                          MACOSX_BUNDLE_LONG_VERSION_STRING "Webcamoid ${VERSION}"
                          MACOSX_BUNDLE_SHORT_VERSION_STRING ${VERSION})
else ()
    set_target_properties(StandAlone PROPERTIES
                          OUTPUT_NAME webcamoid)
endif ()

if (WIN32)
    set_target_properties(StandAlone PROPERTIES
                          WIN32_EXECUTABLE TRUE)
endif ()

if (APPLE)
    set_target_properties(StandAlone PROPERTIES
                          RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build)
elseif (NOT ANDROID)
    set_target_properties(StandAlone PROPERTIES
                          RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${BINDIR})
endif ()

add_dependencies(StandAlone avkys)
target_include_directories(StandAlone
                           PRIVATE ../../libAvKys/Lib/src)
target_compile_definitions(StandAlone
                           PRIVATE $<$<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>:QT_QML_DEBUG>)
list(TRANSFORM QT_COMPONENTS PREPEND Qt${QT_VERSION_MAJOR}:: OUTPUT_VARIABLE QT_LIBS)
target_link_libraries(StandAlone avkys ${QT_LIBS})

if (WIN32)
    target_link_libraries(StandAlone ole32)
endif ()

add_definitions(-DCOMMONS_TARGET="webcamoid"
                -DCOMMONS_APPNAME="Webcamoid"
                -DCOMMONS_VERSION="${VERSION}")
set(QML_IMPORT_PATH ../../libAvKys/Lib/share/qml)

if (APPLE)
    install(TARGETS StandAlone DESTINATION ${CMAKE_INSTALL_PREFIX})
elseif (NOT ANDROID)
    install(TARGETS StandAlone DESTINATION ${BINDIR})
endif ()

if (WIN32)
    install(FILES ../share/themes/WebcamoidTheme/icons/hicolor/256x256/webcamoid.ico
            DESTINATION ${CMAKE_INSTALL_PREFIX})
elseif (UNIX AND NOT APPLE AND NOT ANDROID)
    file(GLOB_RECURSE ICONS
         ../share/themes/WebcamoidTheme/*/webcamoid.png
         ../share/themes/WebcamoidTheme/*/webcamoid.svg)

    foreach (ICON IN LISTS ICONS)
        file(RELATIVE_PATH ICON_DST ${CMAKE_CURRENT_SOURCE_DIR}/../share/themes/WebcamoidTheme ${ICON})
        get_filename_component(INSTALL_DIR ${ICON_DST} DIRECTORY)
        string(APPEND INSTALL_DIR /apps)
        install(FILES ${ICON} DESTINATION ${DATAROOTDIR}/${INSTALL_DIR})
    endforeach ()
endif ()

if (ANDROID)
    set(ANDROID_PACKAGE_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../share/android")
    file(GLOB_RECURSE ANDROID_PACKAGE_TEMPLATES
         ../share/android/*)

    foreach (FILE IN LISTS ANDROID_PACKAGE_TEMPLATES)
        file(RELATIVE_PATH FILE_DST ${CMAKE_CURRENT_SOURCE_DIR}/../share/android ${FILE})
        configure_file(${FILE} "${CMAKE_BINARY_DIR}/android-build/${FILE_DST}" COPYONLY)
    endforeach ()
endif()

=== libAvKys/Lib/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(avkys LANGUAGES CXX)

include(../cmake/ProjectCommons.cmake)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_COMPONENTS
    Quick
    Widgets)
find_package(QT NAMES Qt${QT_VERSION_MAJOR} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${QT_MINIMUM_VERSION} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
add_library(avkys SHARED
            src/ak.cpp
            src/ak.h
            src/akaudiocaps.cpp
            src/akaudiocaps.h
            src/akaudioconverter.cpp
            src/akaudioconverter.h
            src/akaudiopacket.cpp
            src/akaudiopacket.h
            src/akcaps.cpp
            src/akcaps.h
            src/akcommons.h
            src/akelement.cpp
            src/akelement.h
            src/akfrac.cpp
            src/akfrac.h
            src/akmultimediasourceelement.cpp
            src/akmultimediasourceelement.h
            src/akpacket.cpp
            src/akpacket.h
            src/akplugin.h
            src/akplugininfo.cpp
            src/akplugininfo.h
            src/akpluginmanager.cpp
            src/akpluginmanager.h
            src/akunit.cpp
            src/akunit.h
            src/akvideocaps.cpp
            src/akvideocaps.h
            src/akvideopacket.cpp
            src/akvideopacket.h
            src/qml/akcolorizedimage.cpp
            src/qml/akcolorizedimage.h
            src/qml/akutils.cpp
            src/qml/akutils.h
            src/qml/akpalette.cpp
            src/qml/akpalette.h
            src/qml/akpalettegroup.cpp
            src/qml/akpalettegroup.h
            src/qml/aktheme.cpp
            src/qml/aktheme.h
            AvKys.qrc)

if (UNIX AND NOT ANDROID AND NOT APPLE)
    set_target_properties(avkys
                          PROPERTIES
                          VERSION ${VERSION}
                          SOVERSION ${VER_MAJ})
endif ()

if (WIN32)
    set_target_properties(avkys PROPERTIES
                          RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${BINDIR})
elseif (NOT ANDROID)
    set_target_properties(avkys PROPERTIES
                          LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${LIBDIR})
endif ()

target_compile_definitions(avkys PRIVATE AVKYS_LIBRARY)
list(TRANSFORM QT_COMPONENTS PREPEND Qt${QT_VERSION_MAJOR}:: OUTPUT_VARIABLE QT_LIBS)
target_link_libraries(avkys ${QT_LIBS})
add_definitions(-DAKCOMMONS_LIBRARY
                -DBINDIR="${BINDIR}"
                -DPLUGINSDIR="${PLUGINSDIR}"
                -DEXTENSION_SHLIB="${CMAKE_SHARED_LIBRARY_SUFFIX}"
                -DPREFIX_SHLIB="${CMAKE_SHARED_LIBRARY_PREFIX}"
                -DPLATFORM_TARGET_SUFFIX="${CMAKE_ANDROID_ARCH_ABI}")

if (WIN32)
    install(TARGETS avkys RUNTIME DESTINATION ${BINDIR})
elseif (NOT ANDROID)
    install(TARGETS avkys DESTINATION ${LIBDIR})
endif ()

=== libAvKys/Plugins/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(Plugins)

# Base plugins

add_subdirectory(ACapsConvert)
add_subdirectory(AudioDevice)
add_subdirectory(AudioGen)
add_subdirectory(DesktopCapture)
add_subdirectory(Multiplex)
add_subdirectory(MultiSink)
add_subdirectory(MultiSrc)
add_subdirectory(VideoCapture)
add_subdirectory(VirtualCamera)

# Video effects

set(NOVIDEOEFFECTS OFF CACHE STRING "No build video effects")

if (NOT NOVIDEOEFFECTS)
    add_subdirectory(AdjustHSL)
    add_subdirectory(Aging)
    add_subdirectory(AspectRatio)
    add_subdirectory(Blur)
    add_subdirectory(Cartoon)
    add_subdirectory(ChangeHSL)
    add_subdirectory(Charify)
    add_subdirectory(Cinema)
    add_subdirectory(ColorFilter)
    add_subdirectory(ColorReplace)
    add_subdirectory(ColorTap)
    add_subdirectory(ColorTransform)
    add_subdirectory(Contrast)
    add_subdirectory(Convolve)
    add_subdirectory(DelayGrab)
    add_subdirectory(Denoise)
    add_subdirectory(Dice)
    add_subdirectory(Distort)
    add_subdirectory(Dizzy)
    add_subdirectory(Edge)
    add_subdirectory(Emboss)
    add_subdirectory(Equalize)
    add_subdirectory(FaceDetect)
    add_subdirectory(FaceTrack)
    add_subdirectory(FalseColor)
    add_subdirectory(Fire)
    add_subdirectory(Flip)
    add_subdirectory(FrameOverlap)
    add_subdirectory(Gamma)
    add_subdirectory(GrayScale)
    add_subdirectory(Halftone)
    add_subdirectory(Hypnotic)
    add_subdirectory(Implode)
    add_subdirectory(Invert)
    add_subdirectory(Life)
    add_subdirectory(Matrix)
    add_subdirectory(MatrixTransform)
    add_subdirectory(Nervous)
    add_subdirectory(Normalize)
    add_subdirectory(OilPaint)
    add_subdirectory(Otsu)
    add_subdirectory(Photocopy)
    add_subdirectory(Pixelate)
    add_subdirectory(PrimariesColors)
    add_subdirectory(Quark)
    add_subdirectory(Radioactive)
    add_subdirectory(Ripple)
    add_subdirectory(Scale)
    add_subdirectory(ScanLines)
    add_subdirectory(Scroll)
    add_subdirectory(Shagadelic)
    add_subdirectory(SwapRB)
    add_subdirectory(Swirl)
    add_subdirectory(Temperature)
    add_subdirectory(Vignette)
    add_subdirectory(Warhol)
    add_subdirectory(Warp)
    add_subdirectory(Wave)
endif ()

=== libAvKys/Plugins/ACapsConvert/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(ACapsConvert LANGUAGES CXX)

include(../../cmake/ProjectCommons.cmake)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_COMPONENTS
    Core)
find_package(QT NAMES Qt${QT_VERSION_MAJOR} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${QT_MINIMUM_VERSION} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
add_library(ACapsConvert SHARED
            src/acapsconvert.cpp
            src/acapsconvert.h
            src/acapsconvertelement.cpp
            src/acapsconvertelement.h
            pspec.json)

if (WIN32)
    set_target_properties(ACapsConvert PROPERTIES
                          RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${PLUGINSDIR})
elseif (NOT ANDROID)
    set_target_properties(ACapsConvert PROPERTIES
                          LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${PLUGINSDIR})
endif ()

add_dependencies(ACapsConvert avkys)
target_include_directories(ACapsConvert
                           PRIVATE ../../Lib/src)
target_compile_definitions(ACapsConvert PRIVATE AVKYS_PLUGIN_ACAPSCONVERT)
list(TRANSFORM QT_COMPONENTS PREPEND Qt${QT_VERSION_MAJOR}:: OUTPUT_VARIABLE QT_LIBS)
target_link_libraries(ACapsConvert avkys ${QT_LIBS})

if (WIN32)
    install(TARGETS ACapsConvert RUNTIME DESTINATION ${PLUGINSDIR})
elseif (NOT ANDROID)
    install(TARGETS ACapsConvert DESTINATION ${PLUGINSDIR})
endif ()

=== libAvKys/Plugins/AdjustHSL/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2022  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(AdjustHSL LANGUAGES CXX)

include(../../cmake/ProjectCommons.cmake)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_COMPONENTS
    Gui
    Qml)
find_package(QT NAMES Qt${QT_VERSION_MAJOR} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${QT_MINIMUM_VERSION} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
add_library(AdjustHSL SHARED
            src/adjusthsl.h
            src/adjusthslelement.h
            src/adjusthsl.cpp
            src/adjusthslelement.cpp
            AdjustHSL.qrc
            pspec.json)

if (WIN32)
    set_target_properties(AdjustHSL PROPERTIES
                          RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${PLUGINSDIR})
elseif (NOT ANDROID)
    set_target_properties(AdjustHSL PROPERTIES
                          LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${PLUGINSDIR})
endif ()

add_dependencies(AdjustHSL avkys)
target_include_directories(AdjustHSL
                           PRIVATE ../../Lib/src)
target_compile_definitions(AdjustHSL PRIVATE AVKYS_PLUGIN_ADJUSTHSL)
list(TRANSFORM QT_COMPONENTS PREPEND Qt${QT_VERSION_MAJOR}:: OUTPUT_VARIABLE QT_LIBS)
target_link_libraries(AdjustHSL avkys ${QT_LIBS})
set(QML_IMPORT_PATH ../../Lib/share/qml)

if (WIN32)
    install(TARGETS AdjustHSL RUNTIME DESTINATION ${PLUGINSDIR})
elseif (NOT ANDROID)
    install(TARGETS AdjustHSL DESTINATION ${PLUGINSDIR})
endif ()

=== libAvKys/Plugins/Aging/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2021  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(Aging LANGUAGES CXX)

include(../../cmake/ProjectCommons.cmake)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_COMPONENTS
    Gui
    Qml)
find_package(QT NAMES Qt${QT_VERSION_MAJOR} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${QT_MINIMUM_VERSION} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
add_library(Aging SHARED
            src/aging.h
            src/agingelement.h
            src/scratch.h
            src/aging.cpp
            src/agingelement.cpp
            src/scratch.cpp
            Aging.qrc
            pspec.json)

if (WIN32)
    set_target_properties(Aging PROPERTIES
                          RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${PLUGINSDIR})
elseif (NOT ANDROID)
    set_target_properties(Aging PROPERTIES
                          LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${PLUGINSDIR})
endif ()

add_dependencies(Aging avkys)
target_include_directories(Aging
                           PRIVATE ../../Lib/src)
target_compile_definitions(Aging PRIVATE AVKYS_PLUGIN_AGING)
list(TRANSFORM QT_COMPONENTS PREPEND Qt${QT_VERSION_MAJOR}:: OUTPUT_VARIABLE QT_LIBS)
target_link_libraries(Aging avkys ${QT_LIBS})
set(QML_IMPORT_PATH ../../Lib/share/qml)

if (WIN32)
    install(TARGETS Aging RUNTIME DESTINATION ${PLUGINSDIR})
elseif (NOT ANDROID)
    install(TARGETS Aging DESTINATION ${PLUGINSDIR})
endif ()

=== libAvKys/Plugins/AspectRatio/CMakeLists.txt ===
# Webcamoid, webcam capture application.
# Copyright (C) 2022  Gonzalo Exequiel Pedone
#
# Webcamoid is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Webcamoid is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Webcamoid. If not, see <http://www.gnu.org/licenses/>.
#
# Web-Site: http://webcamoid.github.io/

cmake_minimum_required(VERSION 3.16)

project(AspectRatio LANGUAGES CXX)

include(../../cmake/ProjectCommons.cmake)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_COMPONENTS
    Gui
    Qml)
find_package(QT NAMES Qt${QT_VERSION_MAJOR} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${QT_MINIMUM_VERSION} COMPONENTS
             ${QT_COMPONENTS}
             REQUIRED)
add_library(AspectRatio SHARED
            src/aspectratio.h
            src/aspectratioelement.h
            src/aspectratio.cpp
            src/aspectratioelement.cpp
            AspectRatio.qrc
            pspec.json)

if (WIN32)
    set_target_properties(AspectRatio PROPERTIES
                          RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${PLUGINSDIR})
elseif (NOT ANDROID)
    set_target_properties(AspectRatio PROPERTIES
                          LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/build/${PLUGINSDIR})
endif ()

add_dependencies(AspectRatio avkys)
target_include_directories(AspectRatio
                           PRIVATE ../../Lib/src)
target_compile_definitions(AspectRatio PRIVATE AVKYS_PLUGIN_ASPECTRATIO)
list(TRANSFORM QT_COMPONENTS PREPEND Qt${QT_VERSION_MAJOR}:: OUTPUT_VARIABLE QT_LIBS)
target_link_libraries(AspectRatio avkys ${QT_LIBS})
set(QML_IMPORT_PATH ../../Lib/share/qml)

if (WIN32)
    install(TARGETS AspectRatio RUNTIME DESTINATION ${PLUGINSDIR})
elseif (NOT ANDROID)
    install(TARGETS AspectRatio DESTINATION ${PLUGINSDIR})
endif ()

## webcamoid 6.2.0

=== debian/changelog ===
webcamoid (6.2.0-3) unstable; urgency=low

  * Upload to unstable.

 -- Herbert Parentes Fortes Neto <hpfn@ig.com.br>  Thu, 31 Dec 2015 12:06:47 -0200

webcamoid (6.2.0-2) experimental; urgency=medium

  * debian/control:
      - Architecture: linux-any
  * debian/libqb6.symbols:
      - removed a line to make symbols compliant
        with all architectures.
  * debian/rules:
      - added override_dh_makeshlibs to provide the right
        package version to dpkg-gensymbols.

 -- Herbert Parentes Fortes Neto <hpfn@ig.com.br>  Tue, 29 Dec 2015 14:54:57 -0200

webcamoid (6.2.0-1) experimental; urgency=low

  * Initial release (Closes: #763913)

 -- Herbert Parentes Fortes Neto <hpfn@ig.com.br>  Fri, 11 Dec 2015 14:21:52 -0200

=== debian/control ===
Source: webcamoid
Section: video
Priority: optional
Maintainer: Herbert Parentes Fortes Neto <hpfn@ig.com.br>
Build-Depends: debhelper (>= 9),
               libavcodec-dev,
               libavdevice-dev,
               libavfilter-dev,
               libavformat-dev,
               libavresample-dev,
               libavutil-dev,
               libpostproc-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libswresample-dev,
               libswscale-dev,
               libv4l-dev,
               linux-libc-dev,
               pkg-config,
               qtdeclarative5-dev,
               qtmultimedia5-dev,
               qttools5-dev-tools
Standards-Version: 3.9.6
Homepage: https://github.com/hipersayanX/webcamoid
Vcs-Git: git://anonscm.debian.org/collab-maint/webcamoid.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/webcamoid.git

Package: webcamoid
Architecture: linux-any
Depends: qb-plugins, qbqml, webcamoid-data, ${misc:Depends}, ${shlibs:Depends}
Description: full featured webcam capture application
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.

Package: libqb6
Section: libs
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: full featured webcam capture application - library
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
 .
 This package contains the library for webcamoid.

Package: libqb6-dev
Section: libdevel
Architecture: linux-any
Depends: libqb6 (= ${binary:Version}), ${misc:Depends}
Description: full featured webcam capture application - dev
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
 .
 This package contains the development files of libqb6.

Package: qb-plugins
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: full featured webcam capture application - plugins
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
 .
 This package contains the plugins for webcamoid.

Package: qbqml
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: full featured webcam capture application - qml module
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
 .
 This package contains the qml module for webcamoid.

Package: webcamoid-data
Architecture: all
Depends: ${misc:Depends}
Description: icons and locale files for webcamoid
 webcamoid allows one to capture, save and view a video stream. It also can
 do a lot of funny things.
 .
 Features:
 .
  * Take pictures and record videos with the webcam.
  * Manages multiple webcams.
  * GUI interface.
  * Custom controls for each webcam.
  * Add funny effects to the webcam.
  * +60 effects available.
  * Effects with live previews.
  * Translated to many languages.
  * Use custom network and local files as capture devices.
  * Capture from desktop.
 .
 This package contains the icons/locale files for webcamoid.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export PVER=$(shell dpkg-parsechangelog --show-field version | cut -d"-" -f1)

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=qmake

override_dh_auto_configure:
	mkdir -p build
	qmake -qt=5 \
		"QMAKE_CFLAGS=${CFLAGS}" \
		"QMAKE_CXXFLAGS=${CXXFLAGS} ${CPPFLAGS}" \
		"QMAKE_LFLAGS=${LDFLAGS}" \
		"LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)" \
                "LOCALEDIR=/usr/share/webcamoid/locale" \
                Webcamoid.pro

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(PVER)

=== debian/watch ===
version=3
https://github.com/hipersayanX/webcamoid/releases .*/archive/v?(\d\S+)\.(?:zip|tar)\.?(?:gz|bz2|xz)?
